<?php

require_once 'base/GpeparamoperEntityBase.php';


/**
 * Enter description here ...
 *
 * @package Entity
 *
 * @author  alessandrobartels
 */
class GpeparamoperEntity extends GpeParamoperEntityBase
{

    const ADMINISTRADOR = 'ADMINISTRADOR';
    const COMUM = 'COMUM';

    private $_parametro;
    private $_nrOrgOperador;


    /** Construtor.
     *
     * @param integer $nrOrgOperador Numero da Organizacao do Operador.
     *
     * @author alessandrobartels - 26/03/12
     */
     /* public function __construct($id = null, $nrOrgOperador){
        parent::__construct($id);
        $this->_nrOrgOperador = $nrOrgOperador;
    }*/


    /**
     * Retorna um registro contendo os parametros do operador.
     *
     * @param string $cdOperador Codigo do operador logado.
     *
     * @return void
     *
     * @author alessandrobartels - 08/06/2011
     */
    public function retornaParametrosOperador($nrOrg, $cdOperador){
        $this->_parametro = Gpeparamoper::retornaParamOper($nrOrg, $cdOperador);
        if (is_object($this->_parametro) === true) {
            return true;
        } else {
            return false;
        }
    }


    /**
     * Retorna o mes de competencia.
     *
     * @param integer $nrorg Numero da Organizacao.
     *
     * @return string
     */
    public function retornaMesCompetencia($nrorg) {
        $obj = Gpeparamoper::retornaParamOperador($nrorg);
        if (is_object($obj) === true) {
            $data = new TkDateTime($obj->getDtmescompetenc());
            $data->setDay(1);
            return $data->toString(TkDateTime::FORMAT_DATE);
        }
    }


    /**
     * Retorna mes de competencia do parametro do operador.
     *
     * @return string
     *
     * @author alessandrobartels - 18/04/2011
     *         alessandrobartels - 08/06/2011 - Retirada a consulta a base. Agora eh feita somente uma vez e
     *         									armazenada na instancia. Comm a instancia ativa retorna o parametro.
     */
    public function retornaMesCompetenciaOperador() {
//        tk_warning(Ambiente::getNrorg());
//        tk_warning(Ambiente::getCdOperador());

        $obj = Gpeparamoper::retornaParamOper(Ambiente::getNrorg(), Ambiente::getCdOperador());
//        tk_warning($obj->getDtmescompetenc());

        if (is_object($obj) === true) {
            $data = new TkDateTime($obj->getDtmescompetenc());
            $data-> setDay(1);
//            tk_warning($data->toString(TkDateTime::FORMAT_DATE));
            return $data->toString(TkDateTime::FORMAT_DATE);
          }

        /*
        if (is_object($this->_parametro) === true) {
            $data = new TkDateTime($this->_parametro->getDtmescompetenc());
            $data-> setDay(1);
            return $data->toString(TkDateTime::FORMAT_DATE);
        }*/
    }


    /**
     * Retorna a Organizacao de trabalho do operador.
     *
     * @return integer | null
     *
     * @author nataliacesario    - 03/06/2011
     *         alessandrobartels - 08/06/2011 - Retirada a consulta a base. Agora eh feita somente uma vez e
     *         									armazenada na instancia. Com a instancia ativa retorna o parametro.
     */
    public function retornaNrOrgTrabalho() {
        /*$obj = Gpeparamoper::retornaParamOper($nrOrg, $cdOperador);
           if (is_object($obj) === true) {
               return $obj->getNrorgtrab();
           }
        */
        if (is_object($this->_parametro) === true) {
            $nrOrgTrab = $this->_parametro->getNrorgtrab();
            if ($nrOrgTrab === null) {
                return null;
            } else {
                return (int)$this->_parametro->getNrorgtrab();
            }
        }
    }


    /**
     * Retorna a Estrutura de trabalho do operador.
     *
     * @return integer | null
     *
     * @author nataliacesario    - 27/03/2012
     */
    public function retornaNrEstruturaTrabalho($nrOrg, $cdOperador) {
        $obj = Gpeparamoper::retornaParamOper($nrOrg, $cdOperador);
           if (is_object($obj) === true) {
               return $obj->getNrestruttrab();
           }
        /*
        if (is_object($this->_parametro) === true) {
            $nrEstrutTrab = $this->_parametro->getNrestruttrab();
            if (empty($nrEstrutTrab) === true) {
                return null;
            } else {
                return (int)$this->_parametro->getNrestruttrab();
            }
        }*/
    }


    /**
     * Retorna o identificador de debug de regras.
     *
     * @return boolean
     *
     * @author alessandrobartels - 07/12/2011
     */
    public function retornaIdDebug() {
        if (is_object($this->_parametro) === true) {
            if ($this->_parametro->getIddebug() === GpeparamoperEntity::IDDEBUG_SIM) {
                return true;
            } else {
                return false;
            }
        }
    }


     /**
     * Retorna o ambiente de salario do operador.
     *
     * @return string
     *
     * @author alessandrobartels - 18/04/2011
     *         alessandrobartels - 08/06/2011 - Retirada a consulta a base. Agora eh feita somente uma vez e
     *         									armazenada na instancia. Com a instancia ativa retorna o parametro.
     */
    public function retornaAmbienteSalarioOperador() {
        /* $obj = Gpeparamoper::retornaParamOperador($nrorg);
           return $obj->getIdsalariooper();
         */
        if (is_object($this->_parametro) === true) {
            return $this->_parametro->getIdambientesal();
        }
    }


     /**
     * Retorna o tipo de modalidade salarial do operador.
     *
     * @return string
     *
     * @author thalesvalias - 12/12/2011
     */
    public function retornaTipoModalidadeSalario() {
        if (is_object($this->_parametro) === true) {
            return $this->_parametro->getNrtpmodalidsal();
        }
    }


    /**
     * Retorna o tipo de modalidade de calculo.
     *
     * @return integer | null
     *
     * @author alessandrobartels  - 20/12/2011
     */
    public function retornaTipoModalidadeCalculo(){
        if (is_object($this->_parametro) === true) {
            return (int)$this->_parametro->getNrtpmodalidcal();
        }
    }


    /**
     * Retorna o numero da ocorrencia de calculo.
     *
     * @return integer | null
     *
     * @author alessandrobartels - 20/12/2011
     */
    public function retornaNrOcorrenciaCalculo(){
        if (is_object($this->_parametro) === true) {
            return (int)$this->_parametro->getNrocorrecal();
        }
    }


    /**
     * Retorna o tipo de operador.
     *
     * @param string $nrOrgPadrao Numero da Organizacao Padrao.
     *
     * @return string
     *
     * @author alessandrobartels - 26/03/2012
     */
    public function retornaTipoOperador($nrOrgOperador, $nrOrgPadrao){
        /* @todo - verifica se a org do operador eh igual a padrao.
         *       - Futuramente sera um parametro do Gpeparamoper.
         */
        if ($nrOrgOperador === $nrOrgPadrao) {
            return self::ADMINISTRADOR;
        } else {
            return self::COMUM;
        }
        
    }



}

