/* SISTEMAS INTEGRADOS TECNISA
   SERVIOS

NOME: INCLUSAO_DE_DUPLICATA

DESCRIO:
GERAO DO BOLETO REAL DE CONTAS A RECEBER REFERENTES A UMA DUPLICATA QUE EST
SENDO INCLUDA.

P_CDFILIAL    - CDIGO DA FILIAL
P_NRLANCTODUP - NMERO DA DUPLICATA
P_NRLANBOLREC - NMERO DO NOVO BOLETO
P_IDRESULT    - IDENTIFICADOR DE RESULTADO
                'N' - OK.
                'A' - CONTAS (VENCIMENTOS) J AGRUPADOS EM OUTRO(S) BOLETO(S) NO SISTEMA DE CONTAS A RECEBER.
                'B' - NO EXISTEM CONTAS ASSOCIADAS  DUPLICATA.
                'C' - NMERO DO BOLETO (INTERNO) NO INFORMADO.
                'G' - BOLETOS J BAIXADOS
                'H' - CONTAS OU BOLETOS PARCELADOS
                'K' - CONTA PRORROGADA - (DESATIVADO)

PARA APLICAR E DEBUGAR
-- @C:\WIN_PRJ\SQL\ORACLE\1010_FINSTP_INCLUSAO_DE_DUPLICATA.SQL;
-- EXECUTE INCLUSAO_DE_DUPLICATA('9999', '0000000000', '0000000000', :P_IDRESULT)
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('XX');

CRIAO:
13/01/00 - EDERSON
*/

IF EXISTS (SELECT
              *
           FROM SYSOBJECTS O, SYSUSERS U
           WHERE
	           O.NAME = 'INCLUSAO_DE_DUPLICATA' AND
	           TYPE = 'P' 			                   AND
            U.UID = O.UID                    AND
            U.NAME = USER)

DROP PROCEDURE INCLUSAO_DE_DUPLICATA
GO

CREATE PROCEDURE INCLUSAO_DE_DUPLICATA
   @P_CDFILIAL    VARCHAR(04),
   @P_NRLANCTODUP VARCHAR(10),
   @P_NRLANBOLREC VARCHAR(10),
   @P_IDRESULT    VARCHAR(01) OUTPUT
AS
   DECLARE @V_CTDTVENBOL   NUMERIC(04);
   DECLARE @V_DTVENCDUP    DATETIME;
   DECLARE @V_CDEMPRESA    VARCHAR(02);
   DECLARE @V_CDMOTIPROR   VARCHAR(02);
   DECLARE @V_CDCLIENTE    VARCHAR(21);
   DECLARE @V_CDTPBAIXAREC VARCHAR(02);
   DECLARE @V_CDREDUCONT   VARCHAR(03);
   DECLARE @V_CTTPRECBOL   NUMERIC;
   DECLARE @V_CTREDUCONT   NUMERIC;
   DECLARE @V_VRBOLETO     NUMERIC(16,2);
   DECLARE @V_PEMULTA      NUMERIC(16,2);
   DECLARE @V_PEMORA       NUMERIC(16,2);
   DECLARE @V_NRREGFOR     NUMERIC;
   DECLARE @V_NRBOLETO     NUMERIC;
   DECLARE @V_NRDUPLIC     NUMERIC;
   DECLARE @V_NRAJDUPLI    NUMERIC;
   DECLARE @V_VRAJDUPLI    NUMERIC(16,2);
   DECLARE @V_CTAJBOL      NUMERIC;
   DECLARE @V_NRBOLBAIXADO NUMERIC;
   DECLARE @V_NRPARCELA    NUMERIC;
   DECLARE @V_NRCNTPROR    NUMERIC;
   DECLARE @V_VRMOVFXBOL   NUMERIC(16,2);
   DECLARE @V_NRNOTFISC    VARCHAR(20);
   DECLARE @V_TXMENSBOL    VARCHAR;
   DECLARE @V_TIPOBAIXA    NUMERIC;

   DECLARE @V_NMRAZSOCCLIE VARCHAR(50);
   DECLARE @V_NMFANTCLIE   VARCHAR(50);
   DECLARE @V_NMTPBAIXAREC VARCHAR(50);
   DECLARE @V_CDTPBAIXA    VARCHAR(2);

   /* VARIVEIS DO CURSOR C_CNTBOL */
   DECLARE @V_CNTBOL_CDFILIBOLREC VARCHAR(04);
   DECLARE @V_CNTBOL_NRLANBOLREC  VARCHAR(10);

   /* VARIVEIS DO CURSOR C_CONTA */
   DECLARE @V_CONTA_CDFILIAL     VARCHAR(04);
   DECLARE @V_CONTA_NRLANCTONF   VARCHAR(10);
   DECLARE @V_CONTA_NRSEQVENREC  VARCHAR(02);
   DECLARE @V_CONTA_NRPARCELAREC VARCHAR(02);
   DECLARE @V_CONTA_DTATUAVENREC DATETIME;
   DECLARE @V_CONTA_VRORIGREC    NUMERIC(16,2);
   DECLARE @V_CONTA_VRATUAREC    NUMERIC(16,2);
   DECLARE @V_CONTA_CDFILIBOLREC VARCHAR(04);
   DECLARE @V_CONTA_NRLANBOLREC  VARCHAR(10);
   DECLARE @V_CONTA_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_CONTA_CDEMPRESA    VARCHAR(02);
   DECLARE @V_CONTA_CDFIMOVFLREC VARCHAR(04);
   DECLARE @V_CONTA_DTMOVFLUXO   DATETIME;
   DECLARE @V_CONTA_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_CONTA_NRNOTAFISC   VARCHAR(20);

   /* VARIVEIS DO CURSOR C_AJUSTE */
   DECLARE @V_AJUSTE_CDFILIAL     VARCHAR(04);
   DECLARE @V_AJUSTE_NRLANCTONF   VARCHAR(10);
   DECLARE @V_AJUSTE_NRSEQVENREC  VARCHAR(02);
   DECLARE @V_AJUSTE_NRPARCELAREC VARCHAR(02);
   DECLARE @V_AJUSTE_DTAJUSTEREC  DATETIME;
   DECLARE @V_AJUSTE_CDAJUCTREC   VARCHAR(04);
   DECLARE @V_AJUSTE_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_AJUSTE_CDEMMFAJCNTR VARCHAR(02);
   DECLARE @V_AJUSTE_CDFIMFAJCNTR VARCHAR(04);
   DECLARE @V_AJUSTE_DTMOVFLUXO   DATETIME;
   DECLARE @V_AJUSTE_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_AJUSTE_VRAJUSTEREC  NUMERIC(16,2);
   DECLARE @V_AJUSTE_IDAJUCTREC   VARCHAR(01);

   /* VARIVEIS DO CURSOR C_AJBOLREC */
   DECLARE @V_AJBOLREC_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_AJBOLREC_CDEMPRESA    VARCHAR(02);
   DECLARE @V_AJBOLREC_CDFILIAL     VARCHAR(04);
   DECLARE @V_AJBOLREC_DTMOVFLUXO   DATETIME;
   DECLARE @V_AJBOLREC_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_AJBOLREC_VRFXAJBOLREC NUMERIC(16,2);
   DECLARE @V_AJBOLREC_IDAJUCTREC   VARCHAR(01);

   /* VARIVEIS DO CURSOR C_AJDUPLI */
   DECLARE @V_AJDUPLI_CDFILIAL     VARCHAR(04);
   DECLARE @V_AJDUPLI_NRLANCTODUP  VARCHAR(10);
   DECLARE @V_AJDUPLI_CDAJUCTREC   VARCHAR(04);
   DECLARE @V_AJDUPLI_VRAJDUPBOLET NUMERIC(16,2);
   DECLARE @V_AJDUPLI_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_AJDUPLI_IDAJUCTREC   VARCHAR(01);

   /* VARIVEIS DO CURSOR C_AJBOLFX */
   DECLARE @V_AJBOLFX_CDFILIAL     VARCHAR(04);
   DECLARE @V_AJBOLFX_NRLANBOLREC  VARCHAR(10);
   DECLARE @V_AJBOLFX_CDAJUCTREC   VARCHAR(04);
   DECLARE @V_AJBOLFX_VRAJBOLREC   NUMERIC(16,2);
   DECLARE @V_AJBOLFX_CDCLASSFINA  VARCHAR(06);
   DECLARE @V_AJBOLFX_IDAJUCTREC   VARCHAR(01);
   DECLARE @V_AJBOLFX_CDEMPRESA    VARCHAR(02);
   DECLARE @V_AJBOLFX_CDFIMOVFLREC VARCHAR(04);
   DECLARE @V_AJBOLFX_DTMOVFLUXO   DATETIME;
   DECLARE @V_AJBOLFX_IDMOVFLUXO   VARCHAR(01);
   DECLARE @V_AJBOLFX_VRATUAREC    NUMERIC(16,2);

   DECLARE @V_MULT                 NUMERIC(16,2);
BEGIN
   SET @V_NRREGFOR      = 0;
   SET @V_NRBOLETO      = 0;
   SET @V_NRDUPLIC      = NULL;
   SET @V_NRBOLBAIXADO  = 0;
   SET @V_NRPARCELA     = NULL;
   SET @V_DTVENCDUP     = NULL;
   SET @V_CDEMPRESA     = NULL;
   SET @V_CDMOTIPROR    = NULL;
   SET @V_CTTPRECBOL    = NULL;
   SET @V_CTREDUCONT    = NULL;
   SET @V_CDTPBAIXAREC  = NULL;
   SET @V_CDREDUCONT    = NULL;
   SET @V_CTAJBOL       = 0;
   SET @V_CDCLIENTE     = NULL;
   SET @V_PEMULTA       = NULL;
   SET @V_PEMORA        = NULL;
   SET @V_PEMULTA       = NULL;
   SET @V_PEMORA        = NULL;
   SET @V_TXMENSBOL     = NULL;
   SET @V_NRAJDUPLI     = 0;

   SET @P_IDRESULT = 'N';

   IF (@P_NRLANCTODUP IS NOT NULL) BEGIN
      /* - VERIFICA SE O BOLETO POSSUI MAIS DE UMA CONTA ----------------------- */
      SELECT
         @V_NRREGFOR = COUNT(*)
      FROM
         CONTARECEBER
      WHERE
         (CDFILIALDUP = @P_CDFILIAL)    AND
         (NRLANCTODUP = @P_NRLANCTODUP) AND
         (NRLANBOLREC IS NOT NULL);
   END;

   IF @V_NRREGFOR > 0 BEGIN
      DECLARE C_CNTBOL CURSOR FOR
      SELECT
         CDFILIBOLREC,
         NRLANBOLREC
      FROM
         CONTARECEBER
      WHERE
         (CDFILIALDUP = @P_CDFILIAL)    AND
         (NRLANCTODUP = @P_NRLANCTODUP) AND
         (NRLANBOLREC IS NOT NULL);

      OPEN C_CNTBOL;

      FETCH NEXT FROM C_CNTBOL INTO @V_CNTBOL_CDFILIBOLREC, @V_CNTBOL_NRLANBOLREC;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT
            @V_NRBOLETO = COUNT(*)
         FROM
            CONTARECEBER
         WHERE
            (CDFILIBOLREC = @V_CNTBOL_CDFILIBOLREC) AND
            (NRLANBOLREC  = @V_CNTBOL_NRLANBOLREC)  AND
            (NRLANBOLREC IS NOT NULL);

         IF @V_NRBOLETO > 1 BEGIN
            SELECT
               @V_NRDUPLIC = COUNT(DISTINCT NRLANCTODUP)
            FROM
               CONTARECEBER
            WHERE
               (CDFILIBOLREC = @V_CNTBOL_CDFILIBOLREC) AND
               (NRLANBOLREC  = @V_CNTBOL_NRLANBOLREC)  AND
               (NRLANBOLREC IS NOT NULL);

            IF @V_NRDUPLIC > 1 BEGIN
               SET @P_IDRESULT = 'A';
            END;
         END;
         FETCH NEXT FROM C_CNTBOL INTO @V_CNTBOL_CDFILIBOLREC, @V_CNTBOL_NRLANBOLREC;
      END;
      CLOSE C_CNTBOL;
      DEALLOCATE C_CNTBOL;
   END
   ELSE BEGIN
      SET @P_IDRESULT = 'B';
   END;

   IF @P_NRLANBOLREC = '' BEGIN
      SET @P_IDRESULT = 'C';
   END;

   /* - VERIFICA SE O BOLETO J FOI BAIXADO ---------------------------------- */
   SELECT
      @V_NRBOLBAIXADO = COUNT(*)
   FROM
      CONTARECEBER CR,
      BOLETRECEBER BO
   WHERE
      (CDFILIALDUP    = @P_CDFILIAL)     AND
      (NRLANCTODUP    = @P_NRLANCTODUP)  AND
      (BO.CDFILIAL    = CR.CDFILIBOLREC) AND
      (BO.NRLANBOLREC = CR.NRLANBOLREC)  AND
      (BO.NRBAIXAREC IS NOT NULL);

   IF @V_NRBOLBAIXADO > 0 BEGIN
      SET @P_IDRESULT = 'G';
   END;

   /* - VERIFICA SE O CONTA FOI PARCELADA ---------------------------------- */
   /*SELECT
      @V_NRPARCELA = COUNT(DISTINCT NRPARCELAREC)
   FROM
      CONTARECEBER
   WHERE
      (CDFILIALDUP    = @P_CDFILIAL)    AND
      (NRLANCTODUP    = @P_NRLANCTODUP) AND
      (NRLANBOLREC IS NOT NULL);

   IF @V_NRPARCELA > 1 BEGIN
      SET @P_IDRESULT = 'H';
   END; */

   /* - VERIFICA SE A CONTA FOI PRORROGADA ----------------------------------
   SELECT
      COUNT(*)
   INTO
      V_NRCNTPROR
   FROM
      CONTARECEBER
   WHERE
      (CDFILIALDUP  = P_CDFILIAL)    AND
      (NRLANCTODUP  = P_NRLANCTODUP) AND
      (DTORIGVENREC <> DTATUAVENREC)  AND
      (NRLANBOLREC IS NOT NULL);

   IF V_NRCNTPROR > 0 THEN
      P_IDRESULT := 'K';
   END IF;
   */
   IF @P_IDRESULT = 'N' BEGIN
      SELECT
         @V_DTVENCDUP = MAX(DTVENCDUP),
         @V_CDEMPRESA = MAX(CDEMPRESA)
      FROM
         DUPLICATA
      WHERE
         (CDFILIAL    = @P_CDFILIAL) AND
         (NRLANCTODUP = @P_NRLANCTODUP);

      SELECT
         @V_CDMOTIPROR = MAX(CDMOTIPROR)
      FROM
         GERAL_REC;

      /* - VERIFICA SE OS BOLETOS POSSUEM A MESMA CONTA E O MESMO TIPO DE
           RECEBIMENTO PARA GRAVAR NO BOLETO QUE SER GERADO --- */
      SELECT
         @V_CTTPRECBOL = COUNT(DISTINCT B.CDTPBAIXAREC),
         @V_CTREDUCONT = COUNT(DISTINCT B.CDREDUCONT)
      FROM
         BOLETRECEBER B,
         CONTARECEBER C
      WHERE
         (B.CDFILIAL    = C.CDFILIBOLREC) AND
         (B.NRLANBOLREC = C.NRLANBOLREC)  AND
         (CDFILIALDUP  = @P_CDFILIAL)     AND
         (NRLANCTODUP  = @P_NRLANCTODUP);

      IF @V_CTTPRECBOL = 1 AND @V_CTREDUCONT = 1 BEGIN
         SELECT
            @V_CDTPBAIXAREC = MAX(B.CDTPBAIXAREC),
            @V_CDREDUCONT   = MAX(B.CDREDUCONT)
         FROM
            BOLETRECEBER B,
            CONTARECEBER C
         WHERE
            (B.CDFILIAL    = C.CDFILIBOLREC) AND
            (B.NRLANBOLREC = C.NRLANBOLREC)  AND
            (CDFILIALDUP  = @P_CDFILIAL)     AND
            (NRLANCTODUP  = @P_NRLANCTODUP);
      END
      ELSE BEGIN
         SET @V_CDTPBAIXAREC = NULL;
         SET @V_CDREDUCONT   = NULL;
      END;

      SET @V_VRBOLETO  = 0;
      SET @V_NRNOTFISC = '';

      DECLARE C_CONTA CURSOR FOR
         SELECT
            CR.CDFILIAL,     CR.NRLANCTONF,  CR.NRSEQVENREC, CR.NRPARCELAREC,
            CR.DTATUAVENREC, CR.VRORIGREC,   CR.VRATUAREC,   CR.CDFILIBOLREC,
            CR.NRLANBOLREC,  CR.CDCLASSFINA, CR.CDEMPRESA,   CR.CDFIMOVFLREC,
            CR.DTMOVFLUXO,   CR.IDMOVFLUXO,  NF.NRNOTAFISC
         FROM
            CONTARECEBER CR,
            NOTAFISCAL   NF
         WHERE
            (CR.CDFILIALDUP = @P_CDFILIAL   ) AND
            (CR.NRLANCTODUP = @P_NRLANCTODUP) AND
            (NF.CDFILIAL    = CR.CDFILIAL  )  AND
            (NF.NRLANCTONF  = CR.NRLANCTONF)  AND
            (CR.NRLANBOLREC IS NOT NULL);

      OPEN C_CONTA;

      FETCH NEXT FROM C_CONTA INTO @V_CONTA_CDFILIAL,     @V_CONTA_NRLANCTONF,
                                   @V_CONTA_NRSEQVENREC,  @V_CONTA_NRPARCELAREC,
                                   @V_CONTA_DTATUAVENREC, @V_CONTA_VRORIGREC,
                                   @V_CONTA_VRATUAREC,    @V_CONTA_CDFILIBOLREC,
                                   @V_CONTA_NRLANBOLREC,  @V_CONTA_CDCLASSFINA,
                                   @V_CONTA_CDEMPRESA,    @V_CONTA_CDFIMOVFLREC,
                                   @V_CONTA_DTMOVFLUXO,   @V_CONTA_IDMOVFLUXO,
                                   @V_CONTA_NRNOTAFISC;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF @V_NRNOTFISC IS NULL BEGIN
            SET @V_NRNOTFISC = @V_CONTA_NRNOTAFISC;
         END
         ELSE BEGIN
            IF LEN(@V_NRNOTFISC) < 500 BEGIN
               SET @V_NRNOTFISC = @V_NRNOTFISC + '; ' + @V_CONTA_NRNOTAFISC;
            END;
         END;

         SET @V_VRBOLETO = @V_VRBOLETO + @V_CONTA_VRATUAREC; /* SOMA O VALOR DAS CONTAS PARA GRAVAR NO BOLETO */

         /* - PRORROGA A CONTA E ATUALIZA O FLUXO DE CAIXA ------------------ */
      	IF @V_CONTA_DTATUAVENREC <> @V_DTVENCDUP BEGIN

            SET @V_MULT = @V_CONTA_VRORIGREC * -1;
            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CONTA_CDEMPRESA,
                                         @V_CONTA_CDFIMOVFLREC,
                                         @V_CONTA_DTMOVFLUXO,
                                         @V_CONTA_IDMOVFLUXO,
                                         @V_CONTA_CDCLASSFINA,
                                         @V_MULT,
                                         0;

            EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CONTA_CDEMPRESA,
                                         @V_CONTA_CDFIMOVFLREC,
                                         @V_DTVENCDUP,
                                         @V_CONTA_IDMOVFLUXO,
                                         @V_CONTA_CDCLASSFINA,
                                         @V_CONTA_VRORIGREC,
                                         0;

            UPDATE CONTARECEBER
            SET
               DTATUAVENREC = @V_DTVENCDUP,
               CDMOTIPROR   = @V_CDMOTIPROR,
               DTMOVFLUXO   = @V_DTVENCDUP
            WHERE
               (CDFILIAL     = @V_CONTA_CDFILIAL)     AND
               (NRLANCTONF   = @V_CONTA_NRLANCTONF)   AND
               (NRSEQVENREC  = @V_CONTA_NRSEQVENREC)  AND
               (NRPARCELAREC = @V_CONTA_NRPARCELAREC);

            /* -- ATUALIZA O FLUXO DE CAIXA DOS AJUSTES DA CONTA -------------*/
            SELECT
               @V_NRREGFOR = COUNT(*)
            FROM
               AJCTRECEBER
            WHERE
               (CDFILIAL     = @V_CONTA_CDFILIAL)     AND
               (NRLANCTONF   = @V_CONTA_NRLANCTONF)   AND
               (NRSEQVENREC  = @V_CONTA_NRSEQVENREC)  AND
               (NRPARCELAREC = @V_CONTA_NRPARCELAREC);

            IF @V_NRREGFOR > 0 BEGIN
               DECLARE C_AJUSTE CURSOR FOR
               SELECT
                  AJ.CDFILIAL,    AJ.NRLANCTONF, AJ.NRSEQVENREC, AJ.NRPARCELAREC,
                  AJ.DTAJUSTEREC, AJ.CDAJUCTREC, AJ.CDCLASSFINA, AJ.CDEMMFAJCNTR,
                  AJ.CDFIMFAJCNTR, AJ.DTMOVFLUXO, AJ.IDMOVFLUXO, AJ.VRAJUSTEREC,
                  TA.IDAJUCTREC
               FROM
                  TIPOAJRECEBER TA, AJCTRECEBER   AJ
               WHERE
                  (AJ.CDFILIAL     = @V_CONTA_CDFILIAL)     AND
                  (AJ.NRLANCTONF   = @V_CONTA_NRLANCTONF)   AND
                  (AJ.NRSEQVENREC  = @V_CONTA_NRSEQVENREC)  AND
                  (AJ.NRPARCELAREC = @V_CONTA_NRPARCELAREC) AND
                  (TA.CDAJUCTREC   = AJ.CDAJUCTREC);

               OPEN C_AJUSTE;

               FETCH NEXT FROM C_AJUSTE INTO @V_AJUSTE_CDFILIAL,     @V_AJUSTE_NRLANCTONF,
                                             @V_AJUSTE_NRSEQVENREC,  @V_AJUSTE_NRPARCELAREC,
                                             @V_AJUSTE_DTAJUSTEREC,  @V_AJUSTE_CDAJUCTREC,
                                             @V_AJUSTE_CDCLASSFINA,  @V_AJUSTE_CDEMMFAJCNTR,
                                             @V_AJUSTE_CDFIMFAJCNTR, @V_AJUSTE_DTMOVFLUXO,
                                             @V_AJUSTE_IDMOVFLUXO,   @V_AJUSTE_VRAJUSTEREC,
                                             @V_AJUSTE_IDAJUCTREC;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  IF @V_AJUSTE_IDAJUCTREC = 'A' BEGIN

                     SET @V_MULT = @V_AJUSTE_VRAJUSTEREC * -1;

                     EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTE_CDEMMFAJCNTR,
                                                  @V_AJUSTE_CDFIMFAJCNTR,
                                                  @V_AJUSTE_DTMOVFLUXO,
                                                  @V_AJUSTE_IDMOVFLUXO,
                                                  @V_AJUSTE_CDCLASSFINA,
                                                  @V_MULT,
                                                  0;

                     EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTE_CDEMMFAJCNTR,
                                                  @V_AJUSTE_CDFIMFAJCNTR,
                                                  @V_DTVENCDUP,
                                                  @V_AJUSTE_IDMOVFLUXO,
                                                  @V_AJUSTE_CDCLASSFINA,
                                                  @V_AJUSTE_VRAJUSTEREC,
                                                  0;

                  END
                  ELSE BEGIN
                     EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTE_CDEMMFAJCNTR,
                                                  @V_AJUSTE_CDFIMFAJCNTR,
                                                  @V_AJUSTE_DTMOVFLUXO,
                                                  @V_AJUSTE_IDMOVFLUXO,
                                                  @V_AJUSTE_CDCLASSFINA,
                                                  @V_AJUSTE_VRAJUSTEREC,
                                                  0;

                     SET @V_MULT = @V_AJUSTE_VRAJUSTEREC * -1;
                     EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJUSTE_CDEMMFAJCNTR,
                                                  @V_AJUSTE_CDFIMFAJCNTR,
                                                  @V_DTVENCDUP,
                                                  @V_AJUSTE_IDMOVFLUXO,
                                                  @V_AJUSTE_CDCLASSFINA,
                                                  @V_MULT,
                                                  0;
                  END;

                  UPDATE AJCTRECEBER
                  SET DTMOVFLUXO = @V_DTVENCDUP
                  WHERE
                     (CDFILIAL     = @V_AJUSTE_CDFILIAL)     AND
                     (NRLANCTONF   = @V_AJUSTE_NRLANCTONF)   AND
                     (NRSEQVENREC  = @V_AJUSTE_NRSEQVENREC)  AND
                     (NRPARCELAREC = @V_AJUSTE_NRPARCELAREC) AND
                     (DTAJUSTEREC  = @V_AJUSTE_DTAJUSTEREC)  AND
                     (CDAJUCTREC   = @V_AJUSTE_CDAJUCTREC)   AND
                     (CDCLASSFINA  = @V_AJUSTE_CDCLASSFINA);

                  FETCH NEXT FROM C_AJUSTE INTO @V_AJUSTE_CDFILIAL,    @V_AJUSTE_NRLANCTONF,
                                                @V_AJUSTE_NRSEQVENREC, @V_AJUSTE_NRPARCELAREC,
                                                @V_AJUSTE_DTAJUSTEREC, @V_AJUSTE_CDAJUCTREC,
                                                @V_AJUSTE_CDCLASSFINA, @V_AJUSTE_CDEMMFAJCNTR,
                                                @V_AJUSTE_CDFIMFAJCNTR,@V_AJUSTE_DTMOVFLUXO,
                                                @V_AJUSTE_IDMOVFLUXO,  @V_AJUSTE_VRAJUSTEREC,
                                                @V_AJUSTE_IDAJUCTREC;

               END;
               CLOSE C_AJUSTE;
               DEALLOCATE C_AJUSTE;
            END;
         END;

         UPDATE CONTARECEBER
         SET CDFILIBOLREC = NULL,
             NRLANBOLREC  = NULL
         WHERE
            (CDFILIBOLREC = @V_CONTA_CDFILIBOLREC) AND
            (NRLANBOLREC  = @V_CONTA_NRLANBOLREC);

         /* -- EXCLUI OS AJUSTES DOS BOLETOS E DESFAZ O FLUXO DE CAIXA -------*/
         SELECT
            @V_CTAJBOL = COUNT(*)
         FROM
            AJBOLREC
         WHERE
            (CDFILIAL    = @V_CONTA_CDFILIBOLREC) AND
            (NRLANBOLREC = @V_CONTA_NRLANBOLREC);

         IF @V_CTAJBOL > 0 BEGIN
            DECLARE C_AJBOLREC CURSOR FOR
            SELECT
               TA.IDAJUCTREC,  MA.CDCLASSFINA, MA.CDEMPRESA,
               MA.CDFILIAL,    MA.DTMOVFLUXO,  MA.IDMOVFLUXO,
               MA.VRFXAJBOLREC
            FROM
               TIPOAJRECEBER TA, MOVFXAJBOLR MA
            WHERE
               (MA.CDFILIBOLREC = @V_CONTA_CDFILIBOLREC) AND
               (MA.NRLANBOLREC  = @V_CONTA_NRLANBOLREC)  AND
               (TA.CDAJUCTREC   = MA.CDAJUCTREC)

            OPEN C_AJBOLREC;

            FETCH NEXT FROM C_AJBOLREC INTO @V_AJBOLREC_IDAJUCTREC,  @V_AJBOLREC_CDCLASSFINA,
                                            @V_AJBOLREC_CDEMPRESA,   @V_AJBOLREC_CDFILIAL,
                                            @V_AJBOLREC_DTMOVFLUXO,  @V_AJBOLREC_IDMOVFLUXO,
                                            @V_AJBOLREC_VRFXAJBOLREC;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               IF @V_AJBOLREC_IDAJUCTREC = 'A' BEGIN

                  SET @V_MULT = @V_AJBOLREC_VRFXAJBOLREC * -1;
                  EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJBOLREC_CDEMPRESA,
                                               @V_AJBOLREC_CDFILIAL,
                                               @V_AJBOLREC_DTMOVFLUXO,
                                               @V_AJBOLREC_IDMOVFLUXO,
                                               @V_AJBOLREC_CDCLASSFINA,
                                               @V_MULT,
                                               0;
               END
               ELSE BEGIN
                  EXEC ATUALIZA_FLUXO_DE_CAIXA @V_AJBOLREC_CDEMPRESA,
                                               @V_AJBOLREC_CDFILIAL,
                                               @V_AJBOLREC_DTMOVFLUXO,
                                               @V_AJBOLREC_IDMOVFLUXO,
                                               @V_AJBOLREC_CDCLASSFINA,
                                               @V_AJBOLREC_VRFXAJBOLREC,
                                               0;
               END;

               FETCH NEXT FROM C_AJBOLREC INTO @V_AJBOLREC_IDAJUCTREC,  @V_AJBOLREC_CDCLASSFINA,
                                               @V_AJBOLREC_CDEMPRESA,   @V_AJBOLREC_CDFILIAL,
                                               @V_AJBOLREC_DTMOVFLUXO,  @V_AJBOLREC_IDMOVFLUXO,
                                               @V_AJBOLREC_VRFXAJBOLREC;

            END;
            CLOSE C_AJBOLREC;
            DEALLOCATE C_AJBOLREC;

            DELETE FROM MOVFXAJBOLR
            WHERE
               (CDFILIBOLREC = @V_CONTA_CDFILIBOLREC) AND
               (NRLANBOLREC  = @V_CONTA_NRLANBOLREC);

            DELETE FROM AJBOLREC
            WHERE
               (CDFILIAL    = @V_CONTA_CDFILIBOLREC) AND
               (NRLANBOLREC = @V_CONTA_NRLANBOLREC);
         END;

         DELETE FROM BOLETRECEBER
         WHERE
            (CDFILIAL    = @V_CONTA_CDFILIBOLREC) AND
            (NRLANBOLREC = @V_CONTA_NRLANBOLREC);

         FETCH NEXT FROM C_CONTA INTO @V_CONTA_CDFILIAL,     @V_CONTA_NRLANCTONF,
                                      @V_CONTA_NRSEQVENREC,  @V_CONTA_NRPARCELAREC,
                                      @V_CONTA_DTATUAVENREC, @V_CONTA_VRORIGREC,
                                      @V_CONTA_VRATUAREC,    @V_CONTA_CDFILIBOLREC,
                                      @V_CONTA_NRLANBOLREC,  @V_CONTA_CDCLASSFINA,
                                      @V_CONTA_CDEMPRESA,    @V_CONTA_CDFIMOVFLREC,
                                      @V_CONTA_DTMOVFLUXO,   @V_CONTA_IDMOVFLUXO,
                                      @V_CONTA_NRNOTAFISC;
      END;
      CLOSE C_CONTA;
      DEALLOCATE C_CONTA;

      /* -- INCLUI O NOVO BOLETO ---------------------------------------------*/
      SET @V_PEMULTA = 0;
      SET @V_PEMORA  = 0;

      SELECT
         @V_CDCLIENTE = MAX(CL.CDCLIENTE),
         @V_PEMULTA = MAX(CL.VRPEMULBCLI),
         @V_PEMORA = MAX(CL.VRPEMORBCLI)
      FROM
         CONTARECEBER CR,
         NOTAFISCAL   NF,
         CLIENTE      CL
      WHERE
         (CR.CDFILIALDUP = @P_CDFILIAL)    AND
         (CR.NRLANCTODUP = @P_NRLANCTODUP) AND
         (NF.CDFILIAL    = CR.CDFILIAL)    AND
         (NF.NRLANCTONF  = CR.NRLANCTONF)  AND
         (CL.CDCLIENTE   = NF.CDCLIENTE);

      IF (@V_PEMULTA IS NULL) OR
         (@V_PEMORA  IS NULL) BEGIN
         SELECT
            @V_PEMULTA = MAX(VRPEMULEMPR),
            @V_PEMORA = MAX(VRPEMOREMPR)
         FROM
            EMPRESA
         WHERE
            (CDEMPRESA = @V_CDEMPRESA);
      END;

      IF (NOT @V_CDREDUCONT IS NULL) BEGIN
         SELECT @V_TXMENSBOL = MAX(CONVERT(VARCHAR, EB.TXMENSBOLETO))
         FROM
            EMPRBANC EB,
            CONTCORR CC
         WHERE
            CC.CDREDUCONT = @V_CDREDUCONT AND
            EB.CDEMPRESA  = @V_CDEMPRESA  AND
            EB.CDBANCO    = CC.CDBANCO;

         IF (NOT @V_TXMENSBOL IS NULL) BEGIN
            IF LEN(@V_TXMENSBOL +' '+@V_NRNOTFISC) < 500 BEGIN
               SET @V_NRNOTFISC = @V_TXMENSBOL +' '+@V_NRNOTFISC;
            END
            ELSE BEGIN
               SET @V_NRNOTFISC = @V_TXMENSBOL;
            END;
         END;
      END;

      IF LEN(@V_NRNOTFISC) > 500 BEGIN
         SET @V_NRNOTFISC = '';
      END;
      
      SET @V_TIPOBAIXA = 0;

      SELECT
         @V_TIPOBAIXA = COUNT(*)
      FROM
         CLIENTE CL, TIPOBAIXAREC TP
      WHERE
             (TP.CDTPBAIXAREC = CL.CDTPBAIXAREC   )
         AND (CL.CDCLIENTE    = @V_CDCLIENTE      );

      IF @V_TIPOBAIXA > 0 BEGIN
         SELECT
            @V_CDTPBAIXA = CL.CDTPBAIXAREC, 
            @V_CDCLIENTE = CL.CDCLIENTE,
            @V_NMRAZSOCCLIE = CL.NMRAZSOCCLIE, 
            @V_NMFANTCLIE = CL.NMFANTCLIE , 
            @V_NMTPBAIXAREC = TP.NMTPBAIXAREC
         FROM
            CLIENTE CL, TIPOBAIXAREC TP
         WHERE
                (TP.CDTPBAIXAREC = CL.CDTPBAIXAREC   )
            AND (CL.CDCLIENTE    = @V_CDCLIENTE       )
         ORDER BY
            CL.NMRAZSOCCLIE;

         IF NOT @V_CDTPBAIXA IS NULL BEGIN
            SET @V_CDTPBAIXAREC = @V_CDTPBAIXA;
         END;
      END;

      INSERT INTO BOLETRECEBER(
         CDFILIAL,    NRLANBOLREC,  CDCLIENTE,   CDEMPRESA,
         VRBOLREC,    VRPEMULBREC,  VRPEMORBREC, VRFINALBREC,
         DTVENBOLREC, CDTPBAIXAREC, CDREDUCONT, TXMENSBOLBOL)
      VALUES(
         @P_CDFILIAL,  @P_NRLANBOLREC,  @V_CDCLIENTE,  @V_CDEMPRESA,
         @V_VRBOLETO,  @V_PEMULTA,      @V_PEMORA,     @V_VRBOLETO,
         @V_DTVENCDUP, @V_CDTPBAIXAREC, @V_CDREDUCONT, @V_NRNOTFISC);

      /* -- GRAVA A CHAVE DO NOVO BOLETO NAS CONTAS DA DUPLICATA -------------*/
      UPDATE CONTARECEBER
      SET CDFILIBOLREC = @P_CDFILIAL,
          NRLANBOLREC  = @P_NRLANBOLREC
      WHERE
         (CDFILIALDUP = @P_CDFILIAL) AND
         (NRLANCTODUP = @P_NRLANCTODUP) AND
         (CDFILIAL+NRLANCTONF) IN (SELECT CDFILIAL+NRLANCTONF
                                    FROM NOTAFISCAL
                                    WHERE IDSTATUS IN ('A', 'E'));

      /* -- GRAVA OS AJUSTES DA DUPLICATA NO BOLETO -------------*/
      SELECT @V_NRAJDUPLI = COUNT(*)
      FROM AJDUPBOLET
      WHERE
          (CDFILIAL     = @P_CDFILIAL)    AND
          (NRLANCTODUP  = @P_NRLANCTODUP);

      IF @V_NRAJDUPLI > 0 BEGIN
         SET @V_VRAJDUPLI = 0;

         DECLARE C_AJDUPLI CURSOR FOR
         SELECT
            AD.CDFILIAL,     AD.NRLANCTODUP, AD.CDAJUCTREC,
            AD.VRAJDUPBOLET, TA.IDAJUCTREC
         FROM
            TIPOAJRECEBER  TA, AJDUPBOLET  AD
         WHERE
            (AD.CDFILIAL    = @P_CDFILIAL)    AND
            (AD.NRLANCTODUP = @P_NRLANCTODUP) AND
            (TA.CDAJUCTREC  = AD.CDAJUCTREC);

         OPEN C_AJDUPLI;

         FETCH NEXT FROM C_AJDUPLI INTO @V_AJDUPLI_CDFILIAL,   @V_AJDUPLI_NRLANCTODUP,
                                        @V_AJDUPLI_CDAJUCTREC, @V_AJDUPLI_VRAJDUPBOLET,
                                        @V_AJDUPLI_IDAJUCTREC;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            INSERT INTO AJBOLREC
               (CDFILIAL, NRLANBOLREC, CDAJUCTREC, VRAJBOLREC)
            VALUES
               (@P_CDFILIAL, @P_NRLANBOLREC, @V_AJDUPLI_CDAJUCTREC, @V_AJDUPLI_VRAJDUPBOLET);

            IF @V_AJDUPLI_IDAJUCTREC = 'A' BEGIN
               SET @V_VRAJDUPLI = @V_VRAJDUPLI + @V_AJDUPLI_VRAJDUPBOLET;
            END
            ELSE BEGIN
               SET @V_VRAJDUPLI = @V_VRAJDUPLI - @V_AJDUPLI_VRAJDUPBOLET;
            END

            FETCH NEXT FROM C_AJDUPLI INTO @V_AJDUPLI_CDFILIAL,   @V_AJDUPLI_NRLANCTODUP,
                                           @V_AJDUPLI_CDAJUCTREC, @V_AJDUPLI_VRAJDUPBOLET,
                                           @V_AJDUPLI_IDAJUCTREC;

         END;
         CLOSE C_AJDUPLI;
         DEALLOCATE C_AJDUPLI;

         /* -- ALTERA O VALOR DO BOLETO -------------*/
         UPDATE BOLETRECEBER
         SET VRFINALBREC = VRFINALBREC + @V_VRAJDUPLI
         WHERE
            (CDFILIAL    = @P_CDFILIAL)    AND
            (NRLANBOLREC = @P_NRLANBOLREC);


         DECLARE C_AJBOLFX CURSOR FOR
         SELECT
            AJ.CDFILIAL,   AJ.NRLANBOLREC,  AJ.CDAJUCTREC,
            AJ.VRAJBOLREC, TA.IDAJUCTREC,   CR.CDCLASSFINA,
            CR.CDEMPRESA,  CR.CDFIMOVFLREC, CR.DTMOVFLUXO,
            CR.IDMOVFLUXO, SUM(CR.VRATUAREC) VRATUAREC
         FROM
            TIPOAJRECEBER  TA, CONTARECEBER CR, AJBOLREC AJ
         WHERE
            (AJ.CDFILIAL    = @P_CDFILIAL)     AND
            (AJ.NRLANBOLREC = @P_NRLANBOLREC)  AND
            (AJ.CDFILIAL    = CR.CDFILIBOLREC) AND
            (AJ.NRLANBOLREC = CR.NRLANBOLREC)  AND
            (TA.CDAJUCTREC  = AJ.CDAJUCTREC)
         GROUP BY
            AJ.CDFILIAL,   AJ.NRLANBOLREC,  AJ.CDAJUCTREC,
            AJ.VRAJBOLREC, TA.IDAJUCTREC,   CR.CDCLASSFINA,
            CR.CDEMPRESA,  CR.CDFIMOVFLREC, CR.DTMOVFLUXO,
            CR.IDMOVFLUXO;

         OPEN C_AJBOLFX;

         FETCH NEXT FROM C_AJBOLFX INTO @V_AJBOLFX_CDFILIAL,   @V_AJBOLFX_NRLANBOLREC,
                                        @V_AJBOLFX_CDAJUCTREC, @V_AJBOLFX_VRAJBOLREC,
                                        @V_AJBOLFX_IDAJUCTREC, @V_AJBOLFX_CDCLASSFINA,
                                        @V_AJBOLFX_CDEMPRESA,  @V_AJBOLFX_CDFIMOVFLREC,
                                        @V_AJBOLFX_DTMOVFLUXO, @V_AJBOLFX_IDMOVFLUXO,
                                        @V_AJBOLFX_VRATUAREC;

         WHILE (@@FETCH_STATUS = 0) BEGIN

            SET @V_VRMOVFXBOL = 0;
            IF @V_VRBOLETO IS NOT NULL BEGIN
               SET @V_VRMOVFXBOL = ROUND((@V_AJBOLFX_VRATUAREC * @V_AJBOLFX_VRAJBOLREC)/@V_VRBOLETO,2);
            END

            IF @V_AJBOLFX_IDAJUCTREC = 'A' BEGIN
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                            @V_AJBOLFX_CDFIMOVFLREC,
                                            @V_DTVENCDUP,
                                            'E',
                                            @V_AJBOLFX_CDCLASSFINA,
                                            @V_VRMOVFXBOL,
                                            0;
            END
            ELSE BEGIN
               SET @V_MULT = @V_VRMOVFXBOL * -1;
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA,
                                            @V_AJBOLFX_CDFIMOVFLREC,
                                            @V_DTVENCDUP,
                                            'E',
                                            @V_AJBOLFX_CDCLASSFINA,
                                            @V_MULT,
                                            0;
            END;

            INSERT INTO MOVFXAJBOLR
               (CDEMPRESA,    CDFILIAL,   DTMOVFLUXO,
                CDCLASSFINA,  IDMOVFLUXO, CDFILIBOLREC,
                NRLANBOLREC,  CDAJUCTREC, VRFXAJBOLREC)
            VALUES
                (@V_CDEMPRESA, @V_AJBOLFX_CDFIMOVFLREC, @V_DTVENCDUP,
                 @V_AJBOLFX_CDCLASSFINA, 'E', @P_CDFILIAL,
                 @P_NRLANBOLREC, @V_AJBOLFX_CDAJUCTREC, @V_VRMOVFXBOL);

            FETCH NEXT FROM C_AJBOLFX INTO @V_AJBOLFX_CDFILIAL,   @V_AJBOLFX_NRLANBOLREC,
                                           @V_AJBOLFX_CDAJUCTREC, @V_AJBOLFX_VRAJBOLREC,
                                           @V_AJBOLFX_IDAJUCTREC, @V_AJBOLFX_CDCLASSFINA,
                                           @V_AJBOLFX_CDEMPRESA,  @V_AJBOLFX_CDFIMOVFLREC,
                                           @V_AJBOLFX_DTMOVFLUXO, @V_AJBOLFX_IDMOVFLUXO,
                                           @V_AJBOLFX_VRATUAREC;

         END;
         CLOSE C_AJBOLFX;
         DEALLOCATE C_AJBOLFX;
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'INCLUSAO_DE_DUPLICATA','5.03.008';
GO

