CREATE TABLE PRODUTOLOCALPESQ (
	NRPRODUTOLOCALPESQ    NUMBER 		  NOT NULL,
	NRLOCALPESQ           NUMBER 		  NOT NULL, 
	CDPRODUTO             VARCHAR2(10) 	  NOT NULL,
	NRGRUPOPRATOPESQ      NUMBER 		  NOT NULL,
	IDEXIBE               VARCHAR2(1) 	  DEFAULT 'S' NOT NULL,  
	NRORDEM               NUMBER		  NOT NULL,
	VRPRECO               FLOAT(126) 	  NULL,
	DSDESCRICAO           VARCHAR2(100),
	URL_FOTO              VARCHAR2(2000),
	IDRESERVA             VARCHAR(1) 	  DEFAULT 'S' NOT NULL,
	NRORG             	  NUMBER 	      DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') 		NOT NULL,
    IDATIVO           	  VARCHAR2(1)     DEFAULT 'S'					NOT NULL,
    DTINCLUSAO        	  DATE            DEFAULT SYSDATE,
    DTULTATU          	  DATE            DEFAULT SYSDATE,
    NRORGINCLUSAO    	  NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERINCLUSAO    	  VARCHAR2(12)    DEFAULT '1' 					NULL,
    NRORGULTATU      	  NUMBER          DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg')		NULL,
    CDOPERULTATU      	  VARCHAR2(12)    DEFAULT '1',
	  CONSTRAINT CKC_IDATIVOPRODLOCALPESQ CHECK (IDATIVO IN('S','N')), 
	  CONSTRAINT CKC_RESERVAPRODLOCALPESQ CHECK (IDRESERVA IN('S','N')),
	  CONSTRAINT CKC_EXIBEPRODUTLOCALPESQ CHECK (IDEXIBE IN('S','N')),
	  CONSTRAINT PK_PRODUTOLOCALPESQ PRIMARY KEY(NRPRODUTOLOCALPESQ),
	  CONSTRAINT FKPLA01320_PRODLOCPESQ_LOC  FOREIGN KEY (NRLOCALPESQ) REFERENCES LOCALPESQ (NRLOCALPESQ) ON DELETE CASCADE,
	  CONSTRAINT FKPLA01321_PRODLOCPESQ_PROD  FOREIGN KEY (CDPRODUTO)  REFERENCES PRODUTO (CDPRODUTO) ON DELETE CASCADE,
	  CONSTRAINT FKPLA01322_PRODLOCPESQ_GRUP  FOREIGN KEY (NRGRUPOPRATOPESQ) REFERENCES GRUPOPRATOPESQ (NRGRUPOPRATOPESQ) ON DELETE CASCADE        
)
/

CREATE INDEX PLA01320_FK ON PRODUTOLOCALPESQ (NRLOCALPESQ ASC)
/

CREATE INDEX PLA01321_FK ON PRODUTOLOCALPESQ (CDPRODUTO ASC)
/

CREATE INDEX PLA01322_FK ON PRODUTOLOCALPESQ (NRGRUPOPRATOPESQ ASC)
/
