var SelectMonthController = function($scope, $rootScope, templateManager, ScreenService, ZhUtil, Query, EventChildPropagation, metaDataFactory) {

	var selectWidget;

	this.getSelectWidget = function () {
		return selectWidget;
	};
	$scope.openField = function(field) {

		if (field.isReadOnly()) {
			return;
		}
		var widgetEvents = [{
			"name": "WidgetAfterMoveRow",
			"code": "args.owner.setSelected(args);",
			"id": 9999
		}];
		selectWidget = metaDataFactory.widgetFactory({
			"id": 0,
			"name": "Widget",
			"label": ScreenService.i18n(field.label),
			"template": "widget/month-picker.html",
			"showDescriptionOrder": false,
			"container": field.widget.container,
			"separator": field.separator,
			"fullNames": field.fullNames,
			"monthNames": field.monthNames,
			"shortMonthNames": field.shortMonthNames,
			"dateFormat": field.dateFormat,
			"selectField": field,
			"isVisible": true,
			"popupNoBlock": false,
			"fields": [],
			"field": field,
			"minDate": field.minDate,
			"maxDate": field.maxDate,
			"actions": [
				{
					"label": ScreenService.i18n("Back"),
					"showAsAction": "back",
					"isVisible": true,
					"showOnForm": true,
					"showOnList": true,
					"events": [
						{
							"name": "ActionEvent",
							"code": "ScreenService.closePopup()",
							"id": 9998
						}
					]
				}
			],
			"events": EventChildPropagation.propagate(widgetEvents, field)
		});

		selectWidget.setSelected = function(args) {
			ScreenService.closePopup();

			var row = args.row;
			var field = args.owner.selectField;

			field.widget.currentRow[field.name] = row;

			if (field.change) {
				field.change();
			}
		};

		ScreenService.openPopup(selectWidget);
	};

	$scope.clearField = function(field) {
		field.widget.currentRow[field.name] = "";
		field.formattedValue = "";

		field.currentYear = moment().get('year');

		if (field.change) {
			field.change();
		}
	};

	function getFormattedValue(date, field) {
		var dateFormat = field.dateFormat || "MM/YYYY";
		var displayFormat = field.displayFormat || dateFormat;

		return moment(date, dateFormat).format(displayFormat);
	}

	function isMonthBlocked(start, end, date, dateFormat){
		if(start && end){
			return !Util.isBetweenDate(start, end, date, dateFormat);
		} else if(start && !end){
			return !Util.isDateGte(date, start, dateFormat);
		} else if(!start && end){
			return !Util.isDateLte(date, end, dateFormat);
		} else {
			return false;
		}
	}

	$scope.$watch(function() {
		return $scope.field.widget.currentRow[$scope.field.name];
	}, function(row) {
		$scope.field.formattedValue = "";
		if (row && !isMonthBlocked($scope.field.minDate, $scope.field.maxDate, row, $scope.field.dateFormat)) {
			$scope.field.formattedValue = getFormattedValue(row, $scope.field);
		} else{
			$scope.field.widget.currentRow[$scope.field.name] = "";
		}
	});
};

ZeedhiController.controller('SelectMonthController', SelectMonthController);